<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: HokuyoUTM30Lx.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_hokuyo_u_t_m30_lx_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">HokuyoUTM30Lx.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_hokuyo_u_t_m30_lx_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// %flair:license{</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// This file is part of the Flair framework distributed under the</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// CECILL-C License, Version 1.0.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// %flair:license}</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"></span><span class="preprocessor">#ifndef HOKUYOUTM30LX_H</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define HOKUYOUTM30LX_H</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_thread_8h.html">Thread.h</a>&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_laser_range_finder_8h.html">LaserRangeFinder.h</a>&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_mutex_8h.html">Mutex.h</a>&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;queue&gt;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">namespace </span>core {</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">class </span>Matrix;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">class </span>SerialPort;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">class </span>Mutex;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;}</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">namespace </span>gui {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">class </span>Tab;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">class </span>TabWidget;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">class </span>RangeFinderPlot;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;}</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;}</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">namespace </span>sensor {</div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx.html">   42</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx.html">HokuyoUTM30Lx</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_thread.html">core::Thread</a>, <span class="keyword">public</span> <a class="code" href="classflair_1_1sensor_1_1_laser_range_finder.html">LaserRangeFinder</a> {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  <a class="code" href="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx.html#a6f06ca6eb398424de3dd8e49199ad0c3">HokuyoUTM30Lx</a>(std::string name,</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;                <a class="code" href="classflair_1_1core_1_1_serial_port.html">core::SerialPort</a> *serialport, uint8_t priority);</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;  <span class="keywordtype">void</span> getMesure(<span class="keywordtype">int</span> startStep, <span class="keywordtype">int</span> endStep, <span class="keywordtype">int</span> clusterCount, <span class="keywordtype">int</span> interval,</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;                 <span class="keywordtype">int</span> scanNumber = 0);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;  <a class="code" href="classflair_1_1core_1_1_matrix.html">core::Matrix</a> *getDatas(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx.html#af71c2d5cbc5f79bf45f759836c6db8a3">UseDefaultPlot</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  <a class="code" href="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx.html#a703cae77132737a94a915e63d55995b5">~HokuyoUTM30Lx</a>();</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  <a class="code" href="classflair_1_1core_1_1_serial_port.html">core::SerialPort</a> *serialport;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;  <a class="code" href="classflair_1_1core_1_1_mutex.html">core::Mutex</a> *bufRetMut;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;  <a class="code" href="classflair_1_1core_1_1_mutex.html">core::Mutex</a> *sendingCmdMut;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;  <a class="code" href="classflair_1_1gui_1_1_tab.html">gui::Tab</a> *main_tab;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  <a class="code" href="classflair_1_1gui_1_1_tab_widget.html">gui::TabWidget</a> *tab;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;  <a class="code" href="classflair_1_1gui_1_1_range_finder_plot.html">gui::RangeFinderPlot</a> *plot;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;  <span class="comment">// matrix</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;  <a class="code" href="classflair_1_1core_1_1_matrix.html">core::Matrix</a> *output;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;  std::queue&lt;std::string&gt; bufRet;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  <span class="keywordtype">void</span> Run(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;  std::string sendCommand(std::string command);</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;  <span class="keywordtype">void</span> startLaser(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;  <span class="keywordtype">void</span> stopLaser(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;  <span class="keywordtype">void</span> resetConfig(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;  <span class="keywordtype">void</span> decodeDatas(std::vector&lt;std::string&gt; datas, <span class="keywordtype">int</span> startStep);</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;  <span class="keyword">static</span> std::vector&lt;std::string&gt; explode(<span class="keyword">const</span> std::string str,</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;                                          <span class="keywordtype">char</span> delimiter);</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;  <span class="keyword">static</span> <span class="keywordtype">int</span> encodeSum(<span class="keyword">const</span> <span class="keywordtype">char</span> *code, <span class="keywordtype">int</span> byte);</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;  <span class="keyword">static</span> <span class="keywordtype">bool</span> checkSum(std::string data);</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;  <span class="keyword">static</span> <span class="keywordtype">float</span> decode2car(<span class="keyword">const</span> <span class="keywordtype">char</span> *data);</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;  <span class="keyword">static</span> <span class="keywordtype">float</span> decode3car(<span class="keyword">const</span> <span class="keywordtype">char</span> *data);</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;  <span class="keyword">static</span> <span class="keywordtype">float</span> decode4car(<span class="keyword">const</span> <span class="keywordtype">char</span> *data);</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;  <span class="keywordtype">void</span> UpdateFrom(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1io__data.html">core::io_data</a> *data){};</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;};</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;} <span class="comment">// end namespace sensor</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;} <span class="comment">// end namespace flair</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="preprocessor">#endif // HOKUYOUTM30LX_H</span></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html">flair::core::io_data</a></div><div class="ttdoc">Abstract class for data types. </div><div class="ttdef"><b>Definition:</b> io_data.h:94</div></div>
<div class="ttc" id="classflair_1_1sensor_1_1_laser_range_finder_html"><div class="ttname"><a href="classflair_1_1sensor_1_1_laser_range_finder.html">flair::sensor::LaserRangeFinder</a></div><div class="ttdoc">Classe generique intégrant les telemetres laser. </div><div class="ttdef"><b>Definition:</b> LaserRangeFinder.h:38</div></div>
<div class="ttc" id="namespaceflair_html"><div class="ttname"><a href="namespaceflair.html">flair</a></div><div class="ttdoc">namespace of the flair Framework </div><div class="ttdef"><b>Definition:</b> Ahrs.h:19</div></div>
<div class="ttc" id="classflair_1_1core_1_1_mutex_html"><div class="ttname"><a href="classflair_1_1core_1_1_mutex.html">flair::core::Mutex</a></div><div class="ttdoc">Class defining a mutex. </div><div class="ttdef"><b>Definition:</b> Mutex.h:29</div></div>
<div class="ttc" id="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx_html"><div class="ttname"><a href="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx.html">flair::sensor::HokuyoUTM30Lx</a></div><div class="ttdoc">Classe intégrant le telemetre laser Hokuyo UTM 30lx. </div><div class="ttdef"><b>Definition:</b> HokuyoUTM30Lx.h:42</div></div>
<div class="ttc" id="classflair_1_1core_1_1_serial_port_html"><div class="ttname"><a href="classflair_1_1core_1_1_serial_port.html">flair::core::SerialPort</a></div><div class="ttdoc">Base class for serial port. </div><div class="ttdef"><b>Definition:</b> SerialPort.h:25</div></div>
<div class="ttc" id="classflair_1_1gui_1_1_tab_widget_html"><div class="ttname"><a href="classflair_1_1gui_1_1_tab_widget.html">flair::gui::TabWidget</a></div><div class="ttdoc">Class displaying a QTabWidget on the ground station. </div><div class="ttdef"><b>Definition:</b> TabWidget.h:29</div></div>
<div class="ttc" id="_thread_8h_html"><div class="ttname"><a href="_thread_8h.html">Thread.h</a></div><div class="ttdoc">Abstract class for a thread. </div></div>
<div class="ttc" id="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx_html_af71c2d5cbc5f79bf45f759836c6db8a3"><div class="ttname"><a href="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx.html#af71c2d5cbc5f79bf45f759836c6db8a3">flair::sensor::HokuyoUTM30Lx::UseDefaultPlot</a></div><div class="ttdeci">void UseDefaultPlot(void)</div><div class="ttdoc">Use default plot. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_thread_html"><div class="ttname"><a href="classflair_1_1core_1_1_thread.html">flair::core::Thread</a></div><div class="ttdoc">Abstract class for a thread. </div><div class="ttdef"><b>Definition:</b> Thread.h:38</div></div>
<div class="ttc" id="_laser_range_finder_8h_html"><div class="ttname"><a href="_laser_range_finder_8h.html">LaserRangeFinder.h</a></div><div class="ttdoc">Classe generique des telemetres laser. </div></div>
<div class="ttc" id="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx_html_a703cae77132737a94a915e63d55995b5"><div class="ttname"><a href="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx.html#a703cae77132737a94a915e63d55995b5">flair::sensor::HokuyoUTM30Lx::~HokuyoUTM30Lx</a></div><div class="ttdeci">~HokuyoUTM30Lx()</div><div class="ttdoc">Destructor. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_range_finder_plot_html"><div class="ttname"><a href="classflair_1_1gui_1_1_range_finder_plot.html">flair::gui::RangeFinderPlot</a></div><div class="ttdoc">Class displaying a 2D plot on the ground station for laser range finder like Hokuyo. </div><div class="ttdef"><b>Definition:</b> RangeFinderPlot.h:37</div></div>
<div class="ttc" id="_mutex_8h_html"><div class="ttname"><a href="_mutex_8h.html">Mutex.h</a></div><div class="ttdoc">Class defining a mutex. </div></div>
<div class="ttc" id="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx_html_a6f06ca6eb398424de3dd8e49199ad0c3"><div class="ttname"><a href="classflair_1_1sensor_1_1_hokuyo_u_t_m30_lx.html#a6f06ca6eb398424de3dd8e49199ad0c3">flair::sensor::HokuyoUTM30Lx::HokuyoUTM30Lx</a></div><div class="ttdeci">HokuyoUTM30Lx(std::string name, core::SerialPort *serialport, uint8_t priority)</div><div class="ttdoc">Constructor. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_matrix_html"><div class="ttname"><a href="classflair_1_1core_1_1_matrix.html">flair::core::Matrix</a></div><div class="ttdoc">Class defining a matrix. </div><div class="ttdef"><b>Definition:</b> Matrix.h:31</div></div>
<div class="ttc" id="classflair_1_1gui_1_1_tab_html"><div class="ttname"><a href="classflair_1_1gui_1_1_tab.html">flair::gui::Tab</a></div><div class="ttdoc">Class displaying a QTab on the ground station. </div><div class="ttdef"><b>Definition:</b> Tab.h:29</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_33c2ee9b1665499374b4225c427cf176.html">igep</a></li><li class="navelem"><a class="el" href="dir_f1fe274389177bd7e17de7949c4ffada.html">flair-src</a></li><li class="navelem"><a class="el" href="dir_3ef62148cf94871b4b6ee5d6e3a989c1.html">lib</a></li><li class="navelem"><a class="el" href="dir_6e0f9c50eed172896c55a6e61952176b.html">FlairSensorActuator</a></li><li class="navelem"><a class="el" href="dir_c5d95abdcafe7d1171548eb561d7ce37.html">src</a></li><li class="navelem"><a class="el" href="_hokuyo_u_t_m30_lx_8h.html">HokuyoUTM30Lx.h</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
